<?php
/**
 * GepPerfilSituacaoLogic.
 *
 * @package Logic
 * @author  daniellepereira <username@example.com>
 */
class GepPerfilSituacaoLogic {


    /**
    * Gera novo c?o de Perfil de acesso respons?l na Situa? por Tipo de Fluxo.
    *
    * @param integer $nrorg N?o da Organiza?.
    *
    * @return $codigo integer
    */
    public static function retornaProxNumeroPerfilSituacao($nrorg){
        $codigo = GepPerfilsituacaoEntity::retornaProxNumeroPerfilSituacao($nrorg);
        return $codigo;
    }


    /**
     * Retorna dados de um perfil responsavel atraves da situacao.
     *
     * @param  integer $nrorg        Numero da organizacao.
     * @param  integer $nrsituacao   Numero da situacao.
     *
     * @return object|bool
     */
    public static function retornaPerfilSituacao($nrorg, $nrsituacao){
        try{
            $dados = GepPerfilsituacaoEntity::retornaPerfilSituacao($nrorg, $nrsituacao);
            return $dados;
        } catch (Exception $e) {
            switch ($e->getCode()) {
                case GepPerfilsituacaoEntity::SEM_REGISTRO:
                    return GepPerfilsituacaoEntity::SEM_REGISTRO;
                default: tk_message('Erro desconhecido'.$e->getMessage());
                    return false;

            }
        }
    }


}