CREATE OR REPLACE PROCEDURE NF_PAULISTA_VENDA_CONS(
   P_NRLISTA     IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDEMPRESA   IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_NRSEQARQMAG IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_LIVROMAG    IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDINSCESTA  IN NOTAFISCAL.CDINSCESTA%TYPE,
   P_VERSAO      IN VARCHAR)
AS
   V_EMPRESA       VARCHAR2(4000);
   V_DADOS_90      VARCHAR2(4000);
   V_CONTADOR      NUMBER;
   V_QTDE_ITEM     NUMBER;
   V_CONT_REG_20   NUMBER;
   V_CONT_REG_21   NUMBER;
   V_TOTAL_NOTA    NUMBER;
   V_LINHA         VARCHAR2(4000);

BEGIN
   /* sequencial para gerao da nota fiscal paulista */
   V_CONTADOR    := 0000000000;
   V_CONT_REG_20 := 0;
   V_TOTAL_NOTA  := 0;

   /* REGISTRO 10 */
   SELECT '10'        || '|' ||
          P_VERSAO      || '|' ||
          REPLACE(REPLACE(REPLACE(RPAD(NRINSJURIEST, 14, '0'),'/',''),'-',''),'.','')|| '|' ||
          P_DTINICIAL || '|' ||
          P_DTFINAL
     INTO V_EMPRESA
     FROM INSCRESTAD
    WHERE CDEMPRESA = P_CDEMPRESA
      AND CDINSCESTA = P_CDINSCESTA;

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (V_CONTADOR, V_EMPRESA, P_NRSEQARQMAG);
   V_CONTADOR := NVL(V_CONTADOR,0)+1;

   /* REGISTRO 20 */
   FOR C_NOTAS IN (SELECT ARQ_FINAL, CDLISTA, CDFILIAL, NRLANCTONF, NRNOTAFISC, VRNOTAFISC
                   FROM (SELECT '20'                                                                           || '|' ||
                                '1'                                   || '|' || --SERIE
                                ''                                    || '|' ||  --SUB SERIE
                                NRNOTAFISC                            || '|' ||
                                TO_CHAR(N.DTEMISSAO, 'dd/mm/yyyy')    || '|' ||
                                TO_CHAR(N.DTENTRSAID, 'dd/mm/yyyy')   || '|' ||
                                REPLACE(REPLACE(REPLACE(NRINSJURNFPAULI,'-',''),'.',''),'/','')                || '|' ||
                                ''                                    || '|' ||
                                ''                                    || '|' ||
                                ''                                    || '|' || --NUMERO
                                ''                                    || '|' || --DSCOMPENDCLI
                                ''                                    || '|' || --NMBAIRCLIE
                                ''                                    || '|' ||
                                ''                                    || '|' ||
                                ''                                    || '|' ||
                                ''                                    || '|' ||
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VRPRODUTOS),2), '999999999990.00')), '.', ',')  || '|' ||
                                '0,00'                                || '|' || --DESCONTO
                                '0,00'                                || '|' || --FRETE
                                '0,00'                                || '|' || --SEGURO
                                '0,00'                                || '|' || --OUTRAS
                                ''                                    || '|' || --DESCRIO OUTRAS DESPESAS
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VRNOTAFISC),2), '999999999990.00')), '.', ',')  || '|' ||
                                ''                                    || '|' || --INFORMACOES COMPLEMENTARES DO CONTRIBUINTE
                                ''                                    || '|' || --INFORMACOES COMPLEMENTARES DO FISCO
                                '2'                                   || '|' || --REALIZA ENTREGA
                                ''                                    || '|' || --ENDERECO ENTREGA
                                ''                                    || '|' || --NUMERO ENTREGA
                                ''                                    || '|' || --COMPLEMENTO ENTREGA
                                ''                                    || '|' || --BAIRRO ENTREGA
                                ''                                    || '|' || --MUNICIPIO ENTREGA
                                ''                                    || '|' || --UF ENTREGA
                                '2'                                   || '|' || --VENDA A PRAZO
                                ''                                    || '|' || --PRECO A VISTA
                                ''                                    || '|' || --PRECO FINAL
                                ''                                    AS ARQ_FINAL, --QUANTIDADE DE PARCELAS
                                L.CDLISTA, N.CDFILIAL, N.NRLANCTONF, N.NRNOTAFISC, sum(VRNOTAFISC) AS VRNOTAFISC
                         FROM NOTAFISCAL N, TIPOOPERAC T,
                              CLIENTE C, ENDECLIE E, MUNICIPIO M,
                              LISTA L
                         WHERE N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                           AND N.CDINSCESTA = P_CDINSCESTA
                           AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
                           AND N.CDTIPOOPER = T.CDTIPOOPER
                           AND N.CDCLIENTE = C.CDCLIENTE
                           AND C.CDCLIENTE = E.CDCLIENTE
                           AND IDTPENDECLIE = 'P'
                           AND N.IDORIGDESTNF = 'C'
                           AND N.IDENTRSAIDOP = 'S'
                           AND E.CDPAIS = M.CDPAIS
                           AND E.SGESTADO = M.SGESTADO
                           AND E.CDMUNICIPIO = M.CDMUNICIPIO
                           AND L.NRLISTA = P_NRLISTA
                         GROUP BY NRNOTAFISC, TO_CHAR(N.DTEMISSAO, 'dd/mm/yyyy'),
                                  TO_CHAR(N.DTENTRSAID, 'dd/mm/yyyy'), L.CDLISTA, N.CDFILIAL, N.NRLANCTONF,
                                  N.NRNOTAFISC, REPLACE(REPLACE(REPLACE(NRINSJURNFPAULI,'-',''),'.',''),'/','')
                         UNION ALL
                         SELECT '20'                                  || '|' ||
                                '1'                                   || '|' || --SERIE
                                ''                                    || '|' ||  --SUB SERIE
                                NRNOTAFISC                            || '|' ||
                                TO_CHAR(N.DTEMISSAO, 'dd/mm/yyyy')    || '|' ||
                                TO_CHAR(N.DTENTRSAID, 'dd/mm/yyyy')   || '|' ||
                                REPLACE(REPLACE(REPLACE(NRINSJURNFPAULI,'-',''),'.',''),'/','')                       || '|' ||
                                ''                                    || '|' || --SUBSTR(F.NMRAZSOCFORN,1,60)
                                ''                                    || '|' || --SUBSTR(DSENDEFORN,1,60)
                                ''                                    || '|' || --NUMERO
                                ''                                    || '|' || --DSCOMPENDFOR
                                ''                                    || '|' || --NMBAIRFORN
                                ''                                    || '|' ||
                                ''                                    || '|' ||
                                ''                                    || '|' ||
                                ''                                    || '|' ||
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VRPRODUTOS),2), '999999999990.00')), '.', ',')  || '|' ||
                                '0,00'                                || '|' || --DESCONTO
                                '0,00'                                || '|' || --FRETE
                                '0,00'                                || '|' || --SEGURO
                                '0,00'                                || '|' || --OUTRAS
                                ''                                    || '|' || --DESCRIO OUTRAS DESPESAS
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VRNOTAFISC),2), '999999999990.00')), '.', ',')  || '|' ||
                                ''                                    || '|' || --INFORMACOES COMPLEMENTARES DO CONTRIBUINTE
                                ''                                    || '|' || --INFORMACOES COMPLEMENTARES DO FISCO
                                '2'                                   || '|' || --REALIZA ENTREGA
                                ''                                    || '|' || --ENDERECO ENTREGA
                                ''                                    || '|' || --NUMERO ENTREGA
                                ''                                    || '|' || --COMPLEMENTO ENTREGA
                                ''                                    || '|' || --BAIRRO ENTREGA
                                ''                                    || '|' || --MUNICIPIO ENTREGA
                                ''                                    || '|' || --UF ENTREGA
                                '2'                                   || '|' || --VENDA A PRAZO
                                ''                                    || '|' || --PRECO A VISTA
                                ''                                    || '|' || --PRECO FINAL
                                ''                                    AS ARQ_FINAL, --QUANTIDADE DE PARCELAS
                                L.CDLISTA, N.CDFILIAL, N.NRLANCTONF, N.NRNOTAFISC, SUM(VRNOTAFISC) AS VRNOTAFISC
                         FROM NOTAFISCAL N, TIPOOPERAC T,
                              FORNECEDOR F, ENDEFORN E, MUNICIPIO M, LISTA L
                         WHERE N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                           AND N.CDINSCESTA = P_CDINSCESTA
                           AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
                           AND N.CDTIPOOPER = T.CDTIPOOPER
                           AND N.CDFORNECED = F.CDFORNECED
                           AND F.CDFORNECED = E.CDFORNECED
                           AND IDTPENDEFORN = 'P'
                           AND N.IDORIGDESTNF = 'F'
                           AND N.IDENTRSAIDOP = 'S'
                           AND E.CDPAIS = M.CDPAIS
                           AND E.SGESTADO = M.SGESTADO
                           AND E.CDMUNICIPIO = M.CDMUNICIPIO
                           AND L.NRLISTA = P_NRLISTA
                         GROUP BY NRNOTAFISC, TO_CHAR(N.DTEMISSAO, 'dd/mm/yyyy'), TO_CHAR(N.DTENTRSAID, 'dd/mm/yyyy'),
                                L.CDLISTA, N.CDFILIAL, N.NRLANCTONF, N.NRNOTAFISC,
                                REPLACE(REPLACE(REPLACE(NRINSJURNFPAULI,'-',''),'.',''),'/','')
                         UNION ALL
                         SELECT '20'                                  || '|' ||
                                '1'                                   || '|' || --SERIE
                                ''                                    || '|' ||  --SUB SERIE
                                NRNOTAFISC                            || '|' ||
                                TO_CHAR(N.DTEMISSAO, 'dd/mm/yyyy')    || '|' ||
                                TO_CHAR(N.DTENTRSAID, 'dd/mm/yyyy')   || '|' ||
                                REPLACE(REPLACE(REPLACE(NRINSJURNFPAULI,'-',''),'.',''),'/','')   || '|' ||
                                ''                                    || '|' || --SUBSTR(F.NMRAZSOCFILI,1,60)
                                ''                                    || '|' || --SUBSTR(DSENDEFILI,1,60)
                                ''                                    || '|' || --NUMERO
                                ''                                    || '|' || --DSCOMPENDFIL
                                ''                                    || '|' || --NMBAIRFILI
                                ''                                    || '|' || --SUBSTR(NVL(M.NMMUNICIPIO,'EXTERIOR'),1,60)
                                ''                                    || '|' || --NVL(E.SGESTADO,'EX')
                                ''                                    || '|' || --REPLACE(REPLACE(REPLACE(NRCEPFILI,'-',''),'.',''),' ','')
                                ''                                    || '|' || --SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(E.NRTELEFILI,'(',''),')',''),'-',''),' ',''),'.',''),1,10)
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VRPRODUTOS),2), '999999999990.00')), '.', ',')  || '|' ||
                                '0,00'                                || '|' || --DESCONTO
                                '0,00'                                || '|' || --FRETE
                                '0,00'                                || '|' || --SEGURO
                                '0,00'                                || '|' || --OUTRAS
                                ''                                    || '|' || --DESCRIO OUTRAS DESPESAS
                                REPLACE(LTRIM(TO_CHAR(ROUND(SUM(VRNOTAFISC),2), '999999999990.00')), '.', ',')  || '|' ||
                                ''                                    || '|' || --INFORMACOES COMPLEMENTARES DO CONTRIBUINTE
                                ''                                    || '|' || --INFORMACOES COMPLEMENTARES DO FISCO
                                '2'                                   || '|' || --REALIZA ENTREGA
                                ''                                    || '|' || --ENDERECO ENTREGA
                                ''                                    || '|' || --NUMERO ENTREGA
                                ''                                    || '|' || --COMPLEMENTO ENTREGA
                                ''                                    || '|' || --BAIRRO ENTREGA
                                ''                                    || '|' || --MUNICIPIO ENTREGA
                                ''                                    || '|' || --UF ENTREGA
                                '2'                                   || '|' || --VENDA A PRAZO
                                ''                                    || '|' || --PRECO A VISTA
                                ''                                    || '|' || --PRECO FINAL
                                ''                                     AS ARQ_FINAL,  --QUANTIDADE DE PARCELAS
                                L.CDLISTA, N.CDFILIAL, N.NRLANCTONF, N.NRNOTAFISC, SUM(VRNOTAFISC) AS VRNOTAFISC
                         FROM NOTAFISCAL N, TIPOOPERAC T,
                              FILIAL F, ENDEFILI E, MUNICIPIO M, LISTA L
                         WHERE N.CDFILIAL||N.NRLANCTONF = L.CDLISTA
                           AND N.CDINSCESTA = P_CDINSCESTA
                           AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
                           AND N.CDTIPOOPER = T.CDTIPOOPER
                           AND N.CDFILIRECE = F.CDFILIAL
                           AND F.CDFILIAL = E.CDFILIAL
                           AND N.IDENTRSAIDOP = 'S'
                           AND IDTPENDEFILI = 'P'
                           AND N.IDORIGDESTNF = 'L'
                           AND E.CDPAIS = M.CDPAIS
                           AND E.SGESTADO = M.SGESTADO
                           AND E.CDMUNICIPIO = M.CDMUNICIPIO
                           AND L.NRLISTA = P_NRLISTA
                         GROUP BY NRNOTAFISC, TO_CHAR(N.DTEMISSAO, 'dd/mm/yyyy'), TO_CHAR(N.DTENTRSAID, 'dd/mm/yyyy'),
                                L.CDLISTA, N.CDFILIAL, N.NRLANCTONF, N.NRNOTAFISC,
                                REPLACE(REPLACE(REPLACE(NRINSJURNFPAULI,'-',''),'.',''),'/','') )
                   ORDER BY NRNOTAFISC) LOOP

         V_TOTAL_NOTA := NVL(V_TOTAL_NOTA,0) + C_NOTAS.VRNOTAFISC;
         V_CONT_REG_20 := NVL(V_CONT_REG_20,0)+1;

         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           (V_CONTADOR, C_NOTAS.ARQ_FINAL, P_NRSEQARQMAG);
         V_CONTADOR := NVL(V_CONTADOR,0)+1;

         V_QTDE_ITEM := 0;
         /* REGISTRO 21 */
         FOR C_ITENS_NOTAS IN (SELECT (P.CDARVPROD                            || '|' ||
                                       DECODE(IT.CDFISCOPERIT, '5102', '1', '3') || '|' || --TIPO DE RECEITA
                                       P.NMPRODUTO                            || '|' || --DESCRICAO DO PRODUTO
                                       SGUNIDADE                       || '|' || --UNIDADE DE COMERCIALIZACAO
                                       REPLACE(LTRIM(TO_CHAR(ROUND(QTITEMPROD,3), '999999999990.000')), '.', ',')  || '|' || --quantidade
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRUNITITEM,2), '999999999990.00')), '.', ',')  || '|' ||
                                       REPLACE(LTRIM(TO_CHAR(ROUND(VRTOTAITEM,2), '999999999990.00')), '.', ',') ) AS ARQUIVO
                                  FROM ITEMPRODUTO I, PRODUTO P, ITEMPROIMPOS IT, IMPOSTO IM
                                 WHERE I.CDFILIAL   = C_NOTAS.CDFILIAL
                                   AND I.NRLANCTONF = C_NOTAS.NRLANCTONF
                                   AND P.CDPRODUTO   = I.CDPRODUTO
                                   AND I.CDFILIAL    = IT.CDFILIAL
                                   AND I.NRLANCTONF  = IT.NRLANCTONF
                                   AND I.NRSEQITPROD = IT.NRSEQITPROD
                                   AND IM.CDIMPOSTONFE     = '00'
                                   AND IM.CDIMPOSTO   = IT.CDIMPOSTO
                                   AND IT.NRITPROIMPOS = '1' ) LOOP

            V_QTDE_ITEM := NVL(V_QTDE_ITEM,0) + 1;
            V_LINHA := '21' || '|' ||
                       LPAD(TO_CHAR(V_QTDE_ITEM),3,'0') || '|' ||
                       C_ITENS_NOTAS.ARQUIVO;

            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (V_CONTADOR,  V_LINHA,     P_NRSEQARQMAG);
            V_CONTADOR := NVL(V_CONTADOR,0)+1;

            V_CONT_REG_21 := NVL(V_CONT_REG_21,0) + 1;
         END LOOP;

      UPDATE NOTAFISCAL
      SET IDIMPNFPA = 'S'
      WHERE CDFILIAL = C_NOTAS.CDFILIAL
        AND NRLANCTONF = C_NOTAS.NRLANCTONF;

   END LOOP;
   V_DADOS_90 := '90'               || '|' ||
                 LPAD(V_CONT_REG_20, 5, '0')      || '|' ||
                 LPAD(V_CONT_REG_21, 5, '0')      || '|' ||
                 LPAD('0', 5, '0')                || '|' || --quantidade registro 22
                 REPLACE(LTRIM(TO_CHAR(ROUND(V_TOTAL_NOTA,2), '9999999999999990.00')), '.', ',');

   /* REGISTRO 90 */
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (V_CONTADOR, V_DADOS_90 , P_NRSEQARQMAG);
   V_CONTADOR := NVL(V_CONTADOR,0)+1;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('NF_PAULISTA_VENDA_CONS','5.65.000'); END;
/

